;  D5_MiniSolitaire  ( CopyRight olibul@netcourrier.com ) - www.fobec.com
;  ================
;
;  o_Cards.dll est une dll permettant la programmation de jeux de cartes dchargeant le
;  programmeur des problmes de graphismes, de dragging, de gestion des suites de cartes, etc...
; 
;   Voir le fichier d'aide joint.
; 
;   D5_MiniSolitaire est un jeu de Solitaire minimal destin  montrer le peu d'instructions
;    mettre en oeuvre pour programmer un jeu de carte.
; 
;   Le jeu de Solitaire complet est inclus dans ce pakckage sous le nom D5_Solitaire.
; 
;   D5_MiniSolitaire : code source gracieusement livr  titre d'exemple,
;                      exploitation commerciale interdite.

; Adaptation PureBasic : Comtois le 02/01/06
; PB 3.94

XIncludeFile "o_Cards_Constantes.pb"
XIncludeFile "o_Cards_Functions.pb"

o_Cards_Functions_Init()

Declare CallBack(WND,Message,lParam,wParam) 
Declare FormCreate()
Declare Donne1Click()
Declare MouseDown()
Declare MouseUp()
Declare MouseMove()
Declare Jeux1Click()
Declare Annuler1Click()
Declare IsEndGame()

OpenWindow(0, 192,209,696,480,#PB_Window_SystemMenu,"'miniSolitaire - o_Cards.dll")

Enumeration 
#Menu_Donne
#Menu_Annuler
#Menu_Jeux
#Menu_Quitter
#Menu_APropos
EndEnumeration

;- Menu 
If CreateMenu(0, WindowID())
    MenuTitle("Partie")
      MenuItem( #Menu_Donne, "Donne")
      MenuBar()
      MenuItem( #Menu_Annuler, "Annuler")
      MenuItem( #Menu_Jeux, "Jeux...")
      MenuBar()
      MenuItem( #Menu_Quitter, "Quitter")
    MenuTitle("?")
      MenuItem( #Menu_APropos, "'A propos o_Cards.dll")
EndIf
  
DisableMenuItem(#Menu_Annuler, 1)

Global g_GameSolitaire
Global PileDepart 
Global PileDepot
Dim PileCouleur(4)
Dim PileVerticale(7)
Global g_BeginDragCard

FormCreate()
Cards_Paint()	

SetWindowCallback(@CallBack()) 

Repeat

	Event=WaitWindowEvent()
	Select Event 
		Case #WM_LBUTTONDOWN
			MouseDown()
      Case #WM_LBUTTONUP
      	MouseUp()
      Case #WM_MOUSEMOVE
      	MouseMove()	      
      Case #PB_Event_Menu 
      	Select EventMenuID() 
	      	Case #Menu_Donne
	      		Donne1Click()
		      Case #Menu_Annuler
      			Annuler1Click()	
		      Case #Menu_Jeux
      			Jeux1Click()	
      		Case #Menu_Quitter
		      	Quit = 1
	      	Case #Menu_APropos
	      		c_AboutDll()	
	      EndSelect		
      
	EndSelect
Until Event=#PB_Event_CloseWindow Or quit 
Cards_Close()
End

;- Procdures
Procedure CallBack(WND, Message,lParam,wParam) 

    Result = #PB_ProcessPureBasicEvents 
    If WND = WindowID(0)
        Select Message 
        Case #WM_PAINT 
				Cards_Paint()	
        Case #WM_CLOSE 
        		Cards_Close()
            End 
        EndSelect 
    EndIf    
    ProcedureReturn Result 
EndProcedure 
Procedure FormCreate()
;  ****************************************************************
;  *   Procedure INDISPENSABLE                                    *
;  *   A placer dans FormCreate comme TOUTE PREMIERE INSTRUCTION  *
;  ****************************************************************
	Cards_Init(WindowID(0))

  ; c_StackCreate : cre une pile et la rfrence dans le programme 
  PileDepart = c_StackCreate( 12 , 6 , #cStackFixedEffect , #cStackImageO , #False )
  PileDepot = c_StackCreate( 94 , 6 , #cStackFixedEffect , #cStackImageNo , #False )
  c_SetStackFixedEffectNumCards( PileDepot , 1 )

  PileCouleur( 1 ) = c_StackCreate( 258 , 6 , #cStackFixedEffect , #cStackImageGrid , #False )
  PileCouleur( 2 ) = c_StackCreate( 340 , 6 , #cStackFixedEffect , #cStackImageGrid , #False )
  PileCouleur( 3 ) = c_StackCreate( 422 , 6 , #cStackFixedEffect , #cStackImageGrid , #False )
  PileCouleur( 4 ) = c_StackCreate( 504 , 6 , #cStackFixedEffect , #cStackImageGrid , #False )

  PileVerticale( 1 ) = c_StackCreate(  12 , 118 , #cStackDragVer , #cStackImageNo , #False )
  PileVerticale( 2 ) = c_StackCreate(  94 , 118 , #cStackDragVer , #cStackImageNo , #False )
  PileVerticale( 3 ) = c_StackCreate( 176 , 118 , #cStackDragVer , #cStackImageNo , #False )
  PileVerticale( 4 ) = c_StackCreate( 258 , 118 , #cStackDragVer , #cStackImageNo , #False )
  PileVerticale( 5 ) = c_StackCreate( 340 , 118 , #cStackDragVer , #cStackImageNo , #False )
  PileVerticale( 6 ) = c_StackCreate( 422 , 118 , #cStackDragVer , #cStackImageNo , #False )
  PileVerticale( 7 ) = c_StackCreate( 504 , 118 , #cStackDragVer , #cStackImageNo , #False )

  ; Pas de son
  c_SetClickWav( #cCardClickOff )

  ; c_GameCreate : cre une srie de cartes formant un jeu 
  g_GameSolitaire = c_GameCreate( #cGameNormal )

  ; Lancer la partie
  Donne1Click(  )
EndProcedure
Procedure Donne1Click( )
	Protected x , y , numCard , Card

	c_SetClickWav( #cCardClickOff )

	; c_StacksClearAll : vide toutes les piles, efface toute les cartes de la surface de jeu 
  	c_StacksClearAll()

	; c_GameShake : mlange le jeu  
  	c_GameShake( g_GameSolitaire , 0 )

  	; Distribuer les cartes
  	numCard = 1

  	; c_CardMoveToStack : transfre une carte vers une pile 
  	; colonnes
  	For x = 1 To 7 
  		For y = 1 To x 
   		Card = c_GetCardGamePos( g_GameSolitaire , numCard )
      	If y = x : c_SetCardFace( Card , #cCardFace ) : EndIf
      	c_CardMoveToStack( Card , PileVerticale( x ) )
      	numCard + 1
    	Next y
  	Next x

  	; pile dpt
  	For x = numCard To c_GetGameCount( g_GameSolitaire ) 
  		c_CardMoveToStack( c_GetCardGamePos( g_GameSolitaire , x ) , PileDepart );
  	Next x
	Cards_Resize()
  	DisableMenuItem(#Menu_Annuler, 0)
EndProcedure
Procedure MouseDown( )
	Protected   i , totDepart , maxDonne , clickPile
	;*******************************************************************
   ;*   Procedure INDISPENSABLE                                       *
   ;*   A placer dans FormMouseDown comme TOUTE PREMIERE INSTRUCTION  *
   ;*******************************************************************}
  	Cards_MouseDown( WindowMouseX() , WindowMouseY() )

  	; Pile clique
  	clickPile = c_GetStackAtPos() 

  	; Click sur pile PileDepart
  	If clickPile = PileDepart 

   	totDepart = c_GetStackCount( PileDepart )

    	; Plus de cartes sur PileDepart : reprendre les cartes sur PileDepot
    	If totDepart = 0 
      	c_StackReverseFixed( PileDepot , PileDepart )
		EndIf
		
    	; Compacter la pile PileDepot
    	c_StackPackFixedEffect( PileDepot )

    	; Distribuer cartes vers PileDepot
    	maxDonne = totDepart - c_GetStackFixedEffectNumCards( PileDepot ) + 1
    	If maxDonne < 1 : maxDonne = 1 : EndIf
    

    	For i = totDepart To maxDonne Step -1
      	g_BeginDragCard = c_GetCardStackPos( PileDepart , i )
      	c_SetCardFace( g_BeginDragCard , #cCardFace )
      	c_CardMoveToStack( g_BeginDragCard , PileDepot )
      	;Annuler1.Enabled = c_IsCancelEnabled
    	Next

    ProcedureReturn 
  EndIf

  ; Click sur pile verticale: dvoiler la dernire carte
  If c_GetStackModel( clickPile ) = #cStackDragVer 
    If c_GetCardFace( c_GetCardLastInStack( clickPile ) ) = #cCardBack 
      c_SetCardFace( c_GetCardLastInStack( clickPile ) , #cCardFace )
      c_StackRedraw( clickPile , #True )
      DisableMenuItem(#Menu_Annuler, c_IsCancelEnabled()) 
    EndIf
  EndIf  
  
  ; Dragging
  If c_IsDragging() 
    g_BeginDragCard = c_GetCardAtPos()
    If c_GetCardFace( g_BeginDragCard ) = #cCardFace 
    	 c_DragBegin( g_BeginDragCard )
    EndIf  
  EndIf

EndProcedure
Procedure destStack_InPileCouleur(destStack)
	For i = 1 To 4
		If destStack = PileCouleur( i )
			ProcedureReturn #True
		EndIf	
	Next i
	ProcedureReturn #False
EndProcedure
Procedure destStack_InPileVerticale(destStack)
	For i = 1 To 7
		If destStack = PileVerticale( i )
			ProcedureReturn #True
		EndIf	
	Next i
	ProcedureReturn #False
EndProcedure
Procedure MouseUp( )
	Protected destCard , destStack
	; Arrt dragging : conditions
  	If c_IsDragging() 

   	;Pile de destination
    	destStack = c_GetStackAtDrag()

    	; Carte de destination
    	destCard = c_GetCardLastInStack( destStack )
	
    	; Dpot sur une pile couleur
    	If destStack_InPileCouleur( destStack )
      	If ((c_GetStackCount(destStack)=0) And (c_GetCardValue(g_BeginDragCard)=1)) Or ((destCard>0) And ((c_GetCardValue(g_BeginDragCard)=c_GetCardValue(destCard)+1) And (c_GetCardSuite(g_BeginDragCard)=c_GetCardSuite(destCard)))) 
        		c_DragAccept()
      		DisableMenuItem(#Menu_Annuler, c_IsCancelEnabled()) 
    		EndIf
		EndIf
		
    ; Dpt sur colonne alterne
    If destStack_InPileVerticale(destStack)
    ; Drag entre piles
      If ((c_GetStackCount(destStack)=0) And (c_GetCardValue(g_BeginDragCard)=13)) Or ((c_GetCardColor(g_BeginDragCard)<>c_GetCardColor(destCard)) And (c_GetCardValue(g_BeginDragCard)=c_GetCardValue(destCard)-1)) 
        c_DragAccept()
        DisableMenuItem(#Menu_Annuler, c_IsCancelEnabled()) 
      EndIf
    EndIf

    IsEndGame()
  EndIf

	;*****************************************************************
   ;*   Procedure INDISPENSABLE                                     *
   ;*   A placer dans FormMouseUp comme TOUTE DERNIERE INSTRUCTION  *
   ;*****************************************************************}
 	Cards_MouseUp()

EndProcedure
Procedure MouseMove( )
	;*******************************************************************
   ;*   Procedure INDISPENSABLE                                       *
   ;*   A placer dans FormMouseMove comme TOUTE PREMIERE INSTRUCTION  *
   ;*******************************************************************}
  	Cards_MouseMove( WindowMouseX() , WindowMouseY() )
EndProcedure
Procedure Jeux1Click( )
  c_SelectCardBack( #cCardBackAll )
EndProcedure
Procedure Annuler1Click(  )
  c_DoCancel()
  DisableMenuItem(#Menu_Annuler, c_IsCancelEnabled()) 
EndProcedure
Procedure IsEndGame()
	Protected  p , c

   ;? fin de partie
  	p = 0
  	For c = 1 To 4 
   	If c_GetStackCount( PileCouleur( c ) ) = 13 
      	p + 1
		EndIf
	Next c
		
  	If p = 4 
    MessageRequester("Mini Solitaire","Partie Gagne",0 )
	EndIf
EndProcedure
; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 70
; FirstLine = 263
; Folding = --